<?php

namespace App\Policies;

use App\Models\User;
use App\Domain\Payments\Models\Withdrawal;
use Illuminate\Auth\Access\HandlesAuthorization;

class WithdrawalPolicy
{
    use HandlesAuthorization;

    // public function before(User $user)
    // {
    //     if ($user->hasRole('administrators')) {
    //         return true;
    //     }
    // }

    /**
     * Determine whether the user can view any models.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function viewAny(User $user)
    {
        if ($user->hasRole('administrators')) {
            return true;
        }
    }

    /**
     * Determine whether the user can view the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Payments\Models\Withdrawal  $withdrawal
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function view(User $user, Withdrawal $withdrawal)
    {
        if ($user->hasRole('administrators')) {
            return true;
        }
    }

    /**
     * Determine whether the user can create models.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function create(User $user)
    {
        return false;
    }

    /**
     * Determine whether the user can update the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Payments\Models\Withdrawal  $withdrawal
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function update(User $user, Withdrawal $withdrawal)
    {
        //  && $withdrawal->status === 'pending'
        if ($user->hasRole('administrators')) {
            return true;
        }
    }

    /**
     * Determine whether the user can delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Payments\Models\Withdrawal  $withdrawal
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function delete(User $user, Withdrawal $withdrawal)
    {
        //
    }

    /**
     * Determine whether the user can restore the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Payments\Models\Withdrawal  $withdrawal
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function restore(User $user, Withdrawal $withdrawal)
    {
        //
    }

    /**
     * Determine whether the user can permanently delete the model.
     *
     * @param  \App\Models\User  $user
     * @param  \App\Domain\Payments\Models\Withdrawal  $withdrawal
     * @return \Illuminate\Auth\Access\Response|bool
     */
    public function forceDelete(User $user, Withdrawal $withdrawal)
    {
        //
    }
}
